---@diagnostic disable: undefined-doc-name
-- name: \\#OOA572\\Dremy_Bowsers cool moves v1.3
-- description: to many ideas for one moveset so dumping them here
local movesetactive = true
local CT = gMarioStates[0].character.type

function mario_update(m)
    if m.character.type ~= CT_LUIGI then return end
    if not movesetactive then return end
    if m.action == ACT_JUMP and m.actionTimer > 0 and (m.controller.buttonPressed & A_BUTTON) ~= 0 then
        set_mario_action(m, ACT_FLYING_TRIPLE_JUMP, 0)
        m.vel.y = m.vel.y * 0.8
    end
    if m.action == ACT_JUMP then
        m.actionTimer = m.actionTimer + 1
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)
function mario_update(m)
    if m.character.type ~= CT_LUIGI then return end
    if not movesetactive then return end
    if m.action == ACT_GROUND_POUND and m.actionTimer > 0 and (m.controller.buttonPressed & B_BUTTON) ~= 0 then
        set_mario_action(m, ACT_LONG_JUMP, 0)
        m.vel.y = m.vel.y * 2
    end
    if m.action == ACT_LONG_JUMP then
        m.actionTimer = m.actionTimer + 1
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)

function mario_update(m)
    if m.character.type ~= CT_LUIGI then return end
    if not movesetactive then return end
    if m.action == ACT_SIDE_FLIP and m.actionTimer > 0 and (m.controller.buttonPressed & A_BUTTON) ~= 0 then
        set_mario_action(m, ACT_FLYING_TRIPLE_JUMP, 0)
        m.vel.y = m.vel.y * 0.8
    end
    if m.action == ACT_SIDE_FLIP then
        m.actionTimer = m.actionTimer + 1
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)



local haswingcap = false

---@param m MarioState
---@param o Object
---@param interactType InteractionType
---@param interactValue boolean
local function on_interact(m, o, interactType, interactValue)
    if m.character.type ~= CT_LUIGI then return end
    if m.playerIndex ~= 0 then
        return
    end
    if (obj_has_behavior_id(o, id_bhvWingCap) ~= 0) then
        haswingcap = true
    end
end
---@param m MarioState
local function mario_update(m)
    if m.character.type ~= CT_LUIGI then return end
    if m.capTimer == 0 then -- cap wore off
        haswingcap = false
    end
end

---@param m MarioState
local function before_mario_update(m)
    if m.character.type ~= CT_LUIGI then return end
    if m.playerIndex ~= 0 then
        return
    end
    if m.action == ACT_FLYING_TRIPLE_JUMP then
        m.flags = m.flags | MARIO_WING_CAP
    elseif haswingcap ~= true then
        m.flags = m.flags & ~MARIO_WING_CAP
    end
end

hook_event(HOOK_BEFORE_MARIO_UPDATE, before_mario_update)
hook_event(HOOK_MARIO_UPDATE, mario_update)
hook_event(HOOK_MARIO_UPDATE, on_interact)

---@param m MarioState
local function before_mario_update(m)
    if m.character.type ~= CT_LUIGI then return end
    if m.playerIndex ~= 0 then
        return
    end
    if (m.action == ACT_JUMP) or (m.action == ACT_FLYING) or (ACT_FLYING_TRIPLE_JUMP) then
        m.flags = m.flags | MARIO_WING_CAP
    elseif haswingcap ~= true then
        m.flags = m.flags & ~MARIO_WING_CAP
    end
end

hook_event(HOOK_BEFORE_MARIO_UPDATE, before_mario_update)


ANGLE_QUEUE_SIZE = 9
SPIN_TIMER_SUCCESSFUL_INPUT = 4

gMarioStateExtras = {}
for i = 0, (MAX_PLAYERS - 1) do
    gMarioStateExtras[i] = {}
    m = gMarioStates[0]
    e = gMarioStateExtras[i]
    e.angleDeltaQueue = {}
    for j = 0, (ANGLE_QUEUE_SIZE - 1) do e.angleDeltaQueue[j] = 0 end
    e.rotAngle = 0
    e.boostTimer = 0

    e.stickLastAngle = 0
    e.spinDirection = 0
    e.spinBufferTimer = 0
    e.spinInput = 0
    e.lastIntendedMag = 0

    e.lastPos = {}
    e.lastPos.x = m.pos.x
    e.lastPos.y = m.pos.y
    e.lastPos.z = m.pos.z

    e.fakeSavedAction = 0
    e.fakeSavedPrevAction = 0
    e.fakeSavedActionTimer = 0
    e.fakeWroteAction = 0
    e.fakeSaved = false

    e.savedWallSlideHeight = 0
    e.savedWallSlide = false
end

function limit_angle(a)
    return (a + 0x8000) % 0x10000 - 0x8000
end

allocate_mario_action, atan2s, sins, coss, mario_update_moving_sand, mario_update_windy_ground, mario_floor_is_slope, mario_set_forward_vel, set_mario_action, queue_rumble_data_mario, set_jumping_action, play_mario_sound, play_sound, set_mario_animation, common_slide_action, set_anim_to_frame, check_fall_damage_or_get_stuck, play_sound_and_spawn_particles, mario_bonk_reflection, play_mario_landing_sound_once, common_air_action_step, perform_air_step, should_get_stuck_in_ground, play_mario_heavy_landing_sound, check_fall_damage, set_camera_shake_from_hit, drop_and_set_mario_action, stationary_ground_step, check_common_action_exits, stopping_step, mario_drop_held_object, perform_water_step, perform_water_full_step, vec3f_copy, vec3s_set, approach_f32, is_anim_at_end, float_surface_gfx, set_swimming_at_surface_particles, apply_water_current, update_air_without_turn, play_mario_landing_sound, lava_boost_on_wall, check_kick_or_dive_in_air, update_sliding, mario_check_object_grab, mario_grab_used_object, analog_stick_held_back, approach_s32, apply_slope_accel, should_begin_sliding, begin_braking_action, set_jump_from_landing, check_ground_dive_or_punch, anim_and_audio_for_walk, perform_ground_step, push_or_sidle_wall, check_ledge_climb_down, tilt_body_walking, anim_and_audio_for_hold_walk, anim_and_audio_for_heavy_walk, align_with_floor, set_mario_anim_with_accel, play_step_sound =
    allocate_mario_action, atan2s, sins, coss, mario_update_moving_sand, mario_update_windy_ground, mario_floor_is_slope,
    mario_set_forward_vel, set_mario_action, queue_rumble_data_mario, set_jumping_action, play_mario_sound, play_sound,
    set_mario_animation, common_slide_action, set_anim_to_frame, check_fall_damage_or_get_stuck,
    play_sound_and_spawn_particles, mario_bonk_reflection, play_mario_landing_sound_once, common_air_action_step,
    perform_air_step, should_get_stuck_in_ground, play_mario_heavy_landing_sound, check_fall_damage,
    set_camera_shake_from_hit, drop_and_set_mario_action, stationary_ground_step, check_common_action_exits,
    stopping_step, mario_drop_held_object, perform_water_step, perform_water_full_step, vec3f_copy, vec3s_set,
    approach_f32, is_anim_at_end, float_surface_gfx, set_swimming_at_surface_particles, apply_water_current,
    update_air_without_turn, play_mario_landing_sound, lava_boost_on_wall, check_kick_or_dive_in_air, update_sliding,
    mario_check_object_grab, mario_grab_used_object, analog_stick_held_back, approach_s32, apply_slope_accel,
    should_begin_sliding, begin_braking_action, set_jump_from_landing, check_ground_dive_or_punch,
    anim_and_audio_for_walk, perform_ground_step, push_or_sidle_wall, check_ledge_climb_down, tilt_body_walking,
    anim_and_audio_for_hold_walk, anim_and_audio_for_heavy_walk, align_with_floor, set_mario_anim_with_accel,
    play_step_sound

math_sqrt, math_min, math_max, math_floor = math.sqrt, math.min, math.max, math.floor


ACT_ROLL = allocate_mario_action(ACT_GROUP_MOVING | ACT_FLAG_MOVING | ACT_FLAG_BUTT_OR_STOMACH_SLIDE|ACT_FLAG_ATTACKING)
function update_roll_sliding_angle(m, accel, lossFactor)
    if not movesetactive then return end
    if m.character.type ~= CT_LUIGI then return end
    floor = m.floor
    slopeAngle = atan2s(floor.normal.z, floor.normal.x)
    steepness = math_sqrt(floor.normal.x * floor.normal.x + floor.normal.z * floor.normal.z)

    m.slideVelX = m.slideVelX + accel * steepness * sins(slopeAngle)
    m.slideVelZ = m.slideVelZ + accel * steepness * coss(slopeAngle)

    m.slideVelX = m.slideVelX * lossFactor
    m.slideVelZ = m.slideVelZ * lossFactor

    m.slideYaw = atan2s(m.slideVelZ, m.slideVelX)

    facingDYaw = limit_angle(m.faceAngle.y - m.slideYaw)
    newFacingDYaw = facingDYaw

    if newFacingDYaw > 0 and newFacingDYaw <= 0x8000 then
        newFacingDYaw = newFacingDYaw - 0x800
        if newFacingDYaw < 0 then newFacingDYaw = 0 end
    elseif newFacingDYaw >= -0x8000 and newFacingDYaw < 0 then
        newFacingDYaw = newFacingDYaw + 0x800
        if newFacingDYaw > 0 then newFacingDYaw = 0 end
    end

    m.faceAngle.y = limit_angle(m.slideYaw + newFacingDYaw)

    m.vel.x = m.slideVelX
    m.vel.y = 0.0
    m.vel.z = m.slideVelZ

    mario_update_moving_sand(m)
    mario_update_windy_ground(m)


    m.forwardVel = math_sqrt(m.slideVelX * m.slideVelX + m.slideVelZ * m.slideVelZ)
    if m.forwardVel > 100.0 then
        m.slideVelX = m.slideVelX * 100.0 / m.forwardVel
        m.slideVelZ = m.slideVelZ * 100.0 / m.forwardVel
    end
end

function update_roll_sliding(m, stopSpeed)
    if not movesetactive then return end
    if m.character.type ~= CT_LUIGI then return end
    stopped = 0

    intendedDYaw = m.intendedYaw - m.slideYaw
    forward = coss(intendedDYaw)
    sideward = sins(intendedDYaw)


    if forward < 0.0 and m.forwardVel >= 0.0 then
        forward = forward * (0.5 + 0.5 * m.forwardVel / 100.0)
    end

    accel        = 4.0
    lossFactor   = 0.994

    oldSpeed     = math_sqrt(m.slideVelX * m.slideVelX + m.slideVelZ * m.slideVelZ)
    angleChange  = (m.intendedMag / 32.0) * 0.6
    modSlideVelX = m.slideVelZ * angleChange * sideward * 0.05
    modSlideVelZ = m.slideVelX * angleChange * sideward * 0.05

    m.slideVelX  = m.slideVelX + modSlideVelX
    m.slideVelZ  = m.slideVelZ - modSlideVelZ

    newSpeed     = math_sqrt(m.slideVelX * m.slideVelX + m.slideVelZ * m.slideVelZ)

    if oldSpeed > 0.0 and newSpeed > 0.0 then
        m.slideVelX = m.slideVelX * oldSpeed / newSpeed
        m.slideVelZ = m.slideVelZ * oldSpeed / newSpeed
    end

    update_roll_sliding_angle(m, accel, lossFactor)

    if m.playerIndex == 0 and mario_floor_is_slope(m) == 0 and m.forwardVel * m.forwardVel < stopSpeed * stopSpeed then
        mario_set_forward_vel(m, 0.0)
        stopped = 1
    end

    return stopped
end

ACT_ROLL_AIR = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION |
    ACT_FLAG_ATTACKING)
function act_roll(m)
    if not movesetactive then return end
    if m.character.type ~= CT_LUIGI then return end
    e = gMarioStateExtras[m.playerIndex]

    MAX_NORMAL_ROLL_SPEED = 80.0
    ROLL_BOOST_GAIN = 30.0
    ROLL_CANCEL_LOCKOUT_TIME = 10
    BOOST_LOCKOUT_TIME = 0.5

    if m.actionTimer == 0 then
        if m.prevAction ~= ACT_ROLL_AIR then
            e.rotAngle = 0
            e.boostTimer = 0
        end
    elseif m.actionTimer >= ROLL_CANCEL_LOCKOUT_TIME or m.actionArg == 1 then
        if (m.input & INPUT_Z_DOWN) == 0 then
            return set_mario_action(m, ACT_WALKING, 0)
        end
    end

    if (m.input & INPUT_B_PRESSED) ~= 0 then
        queue_rumble_data_mario(m, 5, 80)
        return set_jumping_action(m, ACT_FORWARD_ROLLOUT, 0)
    end

    if (m.input & INPUT_A_PRESSED) ~= 0 then
        return set_jumping_action(m, ACT_LONG_JUMP, 0)
    end

    if (m.controller.buttonPressed & Y_BUTTON) ~= 0 and m.actionTimer > 0 then
        m.vel.y = 19.0
        play_mario_sound(m, SOUND_ACTION_TERRAIN_JUMP, 0)

        if e.boostTimer >= BOOST_LOCKOUT_TIME then
            e.boostTimer = 0

            if m.forwardVel < MAX_NORMAL_ROLL_SPEED then
                mario_set_forward_vel(m, math_min(m.forwardVel + ROLL_BOOST_GAIN, MAX_NORMAL_ROLL_SPEED))
            end

            m.particleFlags = m.particleFlags | PARTICLE_HORIZONTAL_STAR

            play_sound(SOUND_ACTION_SPIN, m.marioObj.header.gfx.cameraToObject)
        end

        return set_mario_action(m, ACT_ROLL_AIR, m.actionArg)
    end

    set_mario_animation(m, MARIO_ANIM_FORWARD_SPINNING)

    if update_roll_sliding(m, 10.0) ~= 0 then
        return set_mario_action(m, ACT_CROUCH_SLIDE, 0)
    end

    common_slide_action(m, ACT_CROUCH_SLIDE, ACT_ROLL_AIR, MARIO_ANIM_FORWARD_SPINNING)

    e.rotAngle = e.rotAngle + (0x80 * m.forwardVel)
    if e.rotAngle > 0x10000 then
        e.rotAngle = e.rotAngle - 0x10000
    end
    set_anim_to_frame(m, 10 * e.rotAngle / 0x10000)

    e.boostTimer = e.boostTimer + 1

    m.actionTimer = m.actionTimer + 1

    return 0
end

function act_roll_air(m)
    if not movesetactive then return end
    if m.character.type ~= CT_LUIGI then return end
    e = gMarioStateExtras[m.playerIndex]
    MAX_NORMAL_ROLL_SPEED = 80.0
    ROLL_AIR_CANCEL_LOCKOUT_TIME = 15

    if m.actionTimer == 0 then
        if m.prevAction ~= ACT_ROLL then
            e.rotAngle   = 0
            e.boostTimer = 0
        end
    end

    if (m.input & INPUT_Z_DOWN) == 0 and m.actionTimer >= ROLL_AIR_CANCEL_LOCKOUT_TIME then
        return set_mario_action(m, ACT_FREEFALL, 0)
    end

    set_mario_animation(m, MARIO_ANIM_FORWARD_SPINNING)

    air_step = perform_air_step(m, 0)
    if air_step == AIR_STEP_LANDED then
        if check_fall_damage_or_get_stuck(m, ACT_HARD_BACKWARD_GROUND_KB) == 0 then
            play_sound_and_spawn_particles(m, SOUND_ACTION_TERRAIN_STEP, 0)
            return set_mario_action(m, ACT_ROLL, m.actionArg)
        end
    elseif air_step == AIR_STEP_HIT_WALL then
        queue_rumble_data_mario(m, 5, 40)
        mario_bonk_reflection(m, false)
        m.faceAngle.y = m.faceAngle.y + 0x8000

        if m.vel.y > 0.0 then
            m.vel.y = 0.0
        end

        m.particleFlags = m.particleFlags | PARTICLE_VERTICAL_STAR
        return set_mario_action(m, ACT_BACKWARD_AIR_KB, 0)
    end

    e.rotAngle = e.rotAngle + 0x80 * m.forwardVel
    if e.rotAngle > 0x10000 then
        e.rotAngle = e.rotAngle - 0x10000
    end

    set_anim_to_frame(m, 10 * e.rotAngle / 0x10000)

    e.boostTimer = e.boostTimer + 1
    m.actionTimer = m.actionTimer + 1

    return false
end

function update_roll(m)
    if not movesetactive then return end
    if m.character.type ~= CT_LUIGI then return end
    if m.action == ACT_DIVE_SLIDE then
        if (m.input & INPUT_ABOVE_SLIDE) == 0 then
            if (m.input & INPUT_Z_DOWN) ~= 0 and m.actionTimer < 2 then
                return set_mario_action(m, ACT_ROLL, 1)
            end
        end
        m.actionTimer = m.actionTimer + 1
    end

    if m.action == ACT_LONG_JUMP_LAND then
        if (m.input & INPUT_Z_DOWN) ~= 0 and m.forwardVel > 15.0 and m.actionTimer < 1 then
            play_mario_landing_sound_once(m, SOUND_ACTION_TERRAIN_LANDING)
            return set_mario_action(m, ACT_ROLL, 1)
        end
    end

    if m.action == ACT_CROUCHING then
        if (m.controller.buttonPressed & Y_BUTTON) ~= 0 then
            m.vel.y = 19.0
            mario_set_forward_vel(m, 32.0)
            play_mario_sound(m, SOUND_ACTION_TERRAIN_JUMP, 0)

            play_sound(SOUND_ACTION_SPIN, m.marioObj.header.gfx.cameraToObject)

            return set_mario_action(m, ACT_ROLL_AIR, 0)
        end
    end

    if m.action == ACT_CROUCH_SLIDE then
        if (m.controller.buttonPressed & Y_BUTTON) ~= 0 then
            m.vel.y = 19.0
            mario_set_forward_vel(m, math_max(32, m.forwardVel))
            play_mario_sound(m, SOUND_ACTION_TERRAIN_JUMP, 0)

            play_sound(SOUND_ACTION_SPIN, m.marioObj.header.gfx.cameraToObject)

            return set_mario_action(m, ACT_ROLL_AIR, 0)
        end
    end

    if m.action == ACT_GROUND_POUND_LAND then
        if (m.controller.buttonPressed & Y_BUTTON) ~= 0 then
            mario_set_forward_vel(m, 60)

            play_sound(SOUND_ACTION_SPIN, m.marioObj.header.gfx.cameraToObject)

            return set_mario_action(m, ACT_ROLL, 0)
        end
    end
end

hook_mario_action(ACT_ROLL, { every_frame = act_roll })
hook_event(HOOK_MARIO_UPDATE, update_roll)
hook_mario_action(ACT_ROLL_AIR, { every_frame = act_roll_air })
hook_mario_action(ACT_ROLL_AIR, update_roll_sliding)
hook_mario_action(ACT_ROLL, update_roll_sliding_angle)

function mario_update(m)
    if not movesetactive then return end
    if m.character.type ~= CT_LUIGI then return end
    if m.action == ACT_FLYING then
        m.forwardVel = m.forwardVel + 0.4
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)

can_press_x = 0

function x_pressed(m)
    if m.action == ACT_STAR_DANCE_EXIT or m.action == ACT_STAR_DANCE_NO_EXIT or m.action == ACT_STAR_DANCE_WATER or m.action == ACT_DEATH_EXIT  or m.action == ACT_DEATH_EXIT_LAND or m.action == ACT_DEATH_ON_BACK   or m.action ==   ACT_DEATH_ON_STOMACH or m.action == ACT_FALLING_DEATH_EXIT or m.action == ACT_QUICKSAND_DEATH  or m.action == ACT_SPECIAL_DEATH_EXIT then return end
    if m.health < 0x100 or m.hurtCounter ~= 0 then return end
    if m.action == ACT_FLYING then return end
    if (m.action & ACT_GROUP_MASK) == ACT_GROUP_SUBMERGED then return end
    if m.playerIndex ~= 0 then return end
    if m.character.type ~= CT_LUIGI then return end
    if not movesetactive then return end
    if m.controller.buttonPressed & X_BUTTON ~= 0 then
        if x_press_counter > 0 then
            set_jumping_action(m, ACT_TRIPLE_JUMP, 0)
            x_press_counter = x_press_counter - 1
        end
    end

    if (m.action & ACT_FLAG_AIR) == 0 then
        x_press_counter = 3
    end
end

hook_event(HOOK_MARIO_UPDATE, x_pressed)

function mario_update(m)
    if not movesetactive then return end
    if m.character.type ~= CT_LUIGI then return end
    if m.action == ACT_TRIPLE_JUMP and m.actionTimer > 0 and (m.controller.buttonPressed & A_BUTTON) ~= 0 then
        set_mario_action(m, ACT_FLYING_TRIPLE_JUMP, 0)
        m.vel.y = m.vel.y * 0.8
    end
    if m.action == ACT_TRIPLE_JUMP then
        m.actionTimer = m.actionTimer + 1
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)



function mario_before_phys_step(m)
    if not movesetactive then return end
    if m.character.type ~= CT_LUIGI then return end

    local hScale = 1.0
    local vScale = 1.0

    if (m.action & ACT_FLAG_SWIMMING) ~= 0 then
        if m.action ~= ACT_BACKWARD_WATER_KB and m.action ~= ACT_FORWARD_WATER_KB then
            hScale = hScale * 1.80
            if m.action ~= ACT_WATER_PLUNGE then
                vScale = vScale * 1.80
            end
        end
    end



    if (m.action & ACT_FLAG_MOVING) ~= 0 then
        hScale = hScale * 1.50
        m.vel.x = m.vel.x * hScale
        m.vel.y = m.vel.y * vScale
        m.vel.z = m.vel.z * hScale
    end
end

hook_event(HOOK_BEFORE_PHYS_STEP, mario_before_phys_step)

function mario_on_set_action(m)
    if not movesetactive then return end
    if m.character.type ~= CT_LUIGI then return end
    if m.action == ACT_LONG_JUMP then
        m.vel.y = m.vel.y + 5
    elseif m.action == ACT_EMERGE_FROM_PIPE then
        m.vel.y = m.vel.y + 10
    end
    if m.action == ACT_JUMP or m.action == ACT_DOUBLE_JUMP or m.action == ACT_TRIPLE_JUMP or m.action == ACT_BACKFLIP or m.action == ACT_SIDE_FLIP or m.action == ACT_WALL_KICK_AIR then
        m.vel.y = m.vel.y + 6
    end
end

function mario_update(m)
    if not movesetactive then return end
    if m.character.type ~= CT_LUIGI then return end
    if m.action == ACT_JUMP or m.action == ACT_DOUBLE_JUMP or m.action == ACT_TRIPLE_JUMP or m.action == ACT_BACKFLIP or m.action == ACT_SIDE_FLIP or m.action == ACT_DIVE or m.action == ACT_JUMP_KICK or m.action == ACT_BACKWARD_ROLLOUT or m.action == ACT_FORWARD_ROLLOUT or m.action == ACT_WATER_JUMP or m.action == ACT_WALL_KICK_AIR then
        m.vel.y = m.vel.y + 0.5
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)
hook_event(HOOK_ON_SET_MARIO_ACTION, mario_on_set_action)

function mario_on_set_action(m)
    if not movesetactive then return end
    if m.character.type ~= CT_LUIGI then return end
    if ACT_TRIPLE_JUMP then set_anim_to_frame(m, 0) end
end

hook_event(HOOK_ON_SET_MARIO_ACTION, mario_on_set_action)

function mario_update(m)
    if not movesetactive then return end
    if m.character.type ~= CT_LUIGI then return end
    if m.action == ACT_FLYING then
        m.particleFlags = m.particleFlags | PARTICLE_SPARKLES
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)





function mario_update(m)
    if m.playerIndex ~= 0 then return end
    if m.character.type ~= CT_LUIGI then return end
    if not movesetactive then return end

    if m.health == 0x500 then
        Explosion = spawn_sync_object(
            id_bhvExplosion,
            E_MODEL_EXPLOSION,
            gMarioStates[0].pos.x, gMarioStates[0].pos.y + 20, gMarioStates[0].pos.z,

            function(obj)
                obj.oBehParams2ndByte = 2
                obj.hurtboxRadius = 500
                obj.hurtboxHeight = 500
            end)
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)




function mario_update(m)
    if not movesetactive then return end
    if m.character.type ~= CT_LUIGI then return end
    if m.action == ACT_GROUND_POUND_LAND and (m.input & INPUT_A_PRESSED) ~= 0 then
        set_mario_action(m, ACT_TRIPLE_JUMP, 0)
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)

function before_mario_phys_step(m)
    if (m.action & ACT_GROUP_MASK) == ACT_GROUP_SUBMERGED then return end
    if not movesetactive then return end
    if m.character.type ~= CT_LUIGI then return end
    if abs_angle_diff(m.faceAngle.y, m.intendedYaw) < 0x5000 then
        if m.action & ACT_GROUP_AIRBORNE ~= 0 and m.action & (ACT_FLAG_DIVING | ACT_FLAG_ATTACKING | ACT_FLAG_INVULNERABLE) == 0 then
            m.faceAngle.y = approach_s16_symmetric(m.faceAngle.y, m.intendedYaw,
                (1 - math.min(m.forwardVel / 60.0, 1.0)) * 0x600)
        end
    end
end

hook_event(HOOK_BEFORE_PHYS_STEP, before_mario_phys_step)



function mario_update(m)
    if m.playerIndex ~= 0 then return end
    if m.character.type ~= CT_LUIGI then return end
    if not movesetactive then return end

    if m.action == ACT_ROLL then
        m.particleFlags = m.particleFlags | PARTICLE_FIRE
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)



-- tf2 crictical rocket moment--
ACT_PAUSA = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR)
ACT_CROCKET = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_ATTACKING |
    ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION)
ACT_CROCKET_FULL = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_ATTACKING |
    ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION)




gStateExtras = {}
for i = 0, (MAX_PLAYERS - 1) do
    gStateExtras[i] = {}
    local m = gMarioStates[i]
    local e = gStateExtras[i]

    e.forca = 0
    e.timer = 0
end




function act_crocket_full(m)
    if m.character.type ~= CT_LUIGI then return end
    if not movesetactive then return end
    local e = gStateExtras[m.playerIndex]

    m.vel.y = 25 - m.actionTimer * 2

    m.particleFlags = m.particleFlags | PARTICLE_DUST | PARTICLE_FIRE

    if m.actionTimer == 1 then
        mario_set_forward_vel(m, 195 + e.forca)
        audioSample = audio_sample_load("Locked in.ogg");
        audio_sample_play(audioSample, gMarioStates[0].pos, 0.32);
        play_character_sound(m, CHAR_SOUND_PUNCH_HOO)
        set_camera_shake_from_point(SHAKE_POS_MEDIUM, m.pos.x, m.pos.y, m.pos.z)
        m.squishTimer = 1.33
        m.particleFlags = m.particleFlags | PARTICLE_VERTICAL_STAR
    else
        mario_set_forward_vel(m, m.forwardVel - m.actionTimer / 230)
    end

    if m.actionTimer > 64 then
        set_mario_action(m, ACT_FREEFALL, 0)
    end

    if m.forwardVel < 0 then
        mario_set_forward_vel(m, 0)
    end

    local stepResult = perform_air_step(m, 0)
    if stepResult == AIR_STEP_LANDED then
        set_mario_action(m, ACT_FORWARD_GROUND_KB, 0)
    elseif stepResult == AIR_STEP_HIT_WALL then
        set_mario_action(m, ACT_HARD_BACKWARD_AIR_KB, 0)
    end

    set_mario_animation(m, MARIO_ANIM_FLUTTERKICK)
    set_anim_to_frame(m, 7)

    m.actionTimer = m.actionTimer + 1
    return
end

function act_crocket(m)
    if m.character.type ~= CT_LUIGI then return end
    if not movesetactive then return end
    local e = gStateExtras[m.playerIndex]

    m.vel.y = 25 - m.actionTimer * 2

    m.particleFlags = m.particleFlags | PARTICLE_FIRE

    if m.actionTimer == 1 then
        mario_set_forward_vel(m, 195 + e.forca)
        audioSample = audio_sample_load("oughmyfckingdick.ogg");
        audio_sample_play(audioSample, gMarioStates[0].pos, 0.24);
        play_character_sound(m, CHAR_SOUND_PUNCH_HOO)
    else
        mario_set_forward_vel(m, m.forwardVel - m.actionTimer / 195)
    end

    if m.actionTimer > 64 then
        set_mario_action(m, ACT_FREEFALL, 0)
    end

    if m.forwardVel < 0 then
        mario_set_forward_vel(m, 0)
    end

    local stepResult = perform_air_step(m, 0)
    if stepResult == AIR_STEP_LANDED then
        set_mario_action(m, ACT_FORWARD_GROUND_KB, 0)
    elseif stepResult == AIR_STEP_HIT_WALL then
        set_mario_action(m, ACT_HARD_BACKWARD_AIR_KB, 0)
    end

    set_mario_animation(m, MARIO_ANIM_FALL_OVER_BACKWARDS)
    set_anim_to_frame(m, 12)

    m.actionTimer = m.actionTimer + 1
    return
end

function act_pausa(m)
    if m.character.type ~= CT_LUIGI then return end
    if not movesetactive then return end
    local e = gStateExtras[m.playerIndex]

    m.particleFlags = m.particleFlags | PARTICLE_SPARKLES

    if m.actionTimer % 14 == 0 and m.actionTimer < 72 then
        m.particleFlags = m.particleFlags | PARTICLE_HORIZONTAL_STAR
        audioSample = audio_sample_load("boing.ogg");
        audio_sample_play(audioSample, gMarioStates[0].pos, 0.32);
        m.vel.y = 0
        e.timer = 0
    end

    if m.actionTimer == 0 then
        m.actionTimer = 1
        e.forca = 0
        e.timer = 0
    else
        if m.forwardVel > 2 then
            mario_set_forward_vel(m, m.forwardVel - 0.05 * (m.actionTimer / 2))
        else
            mario_set_forward_vel(m, 2)
        end

        m.vel.y = m.vel.y / 2 - e.timer / 5

        if e.forca < 72 then
            e.forca = e.forca + 1
        end
    end

    if (m.controller.buttonDown & L_TRIG) == 0 then
        if m.actionTimer < 72 then
            set_mario_action(m, ACT_CROCKET, 0)
        elseif m.actionTimer >= 72 then
            set_mario_action(m, ACT_CROCKET_FULL, 0)
        end
    end
    if m.actionTimer > 104 then
        set_mario_action(m, ACT_SOFT_FORWARD_GROUND_KB, 0)
    end

    local stepResult = perform_air_step(m, 0)
    if stepResult == AIR_STEP_LANDED then
    elseif stepResult == AIR_STEP_HIT_WALL then
        set_mario_action(m, ACT_AIR_HIT_WALL, 0)
    end



    set_mario_animation(m, MARIO_ANIM_BREAKDANCE)


    m.faceAngle.y = m.intendedYaw - approach_s32(convert_s16(m.intendedYaw - m.faceAngle.y), 0, 0x400, 0x400)

    m.actionTimer = m.actionTimer + 1
    e.timer = e.timer + 1
    return
end


function convert_s16(num)
    if not movesetactive then return end
    local min = -32768
    local max = 32767
    while (num < min) do
        num = max + (num - min)
    end
    while (num > max) do
        num = min + (num - max)
    end
    return num
end

function convert_s32(num)
    if not movesetactive then return end
    local min = -32768
    local max = 32767
    while (num < min) do
        num = max + (num - min)
    end
    while (num > max) do
        num = min + (num - max)
    end
    return num
end




function mario_update(m)
    if m.character.type ~= CT_LUIGI then return end
    if not movesetactive then return end
    local e = gStateExtras[m.playerIndex]


    if (m.controller.buttonPressed & L_TRIG) ~= 0 then
        if m.action == ACT_JUMP or
            m.action == ACT_WALL_KICK_AIR or
            m.action == ACT_LONG_JUMP or
            m.action == ACT_SIDE_FLIP or
            m.action == ACT_TRIPLE_JUMP or
            m.action == ACT_DOUBLE_JUMP or
            m.action == ACT_IDLE or
            m.action == ACT_PANTING or
            m.action == ACT_WALKING then
            set_mario_action(m, ACT_PAUSA, 0)
        end
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)

hook_mario_action(ACT_PAUSA, act_pausa)
hook_mario_action(ACT_CROCKET, { every_frame = act_crocket }, INT_KICK)
hook_mario_action(ACT_CROCKET_FULL, { every_frame = act_crocket_full }, INT_KICK)

function mario_update(m)
    if (m.action & ACT_FLAG_IDLE) ~= 0 and (m.controller.buttonDown & R_JPAD) ~= 0 then
        set_mario_action(m, ACT_HARD_BACKWARD_GROUND_KB, 0)
        audioSample = audio_sample_load("Lego Break.ogg");
        audio_sample_play(audioSample, gMarioStates[0].pos, 0.32)
    elseif (m.action & ACT_FLAG_IDLE) ~= 0 and (m.controller.buttonDown & D_JPAD) ~= 0 then
        set_mario_action(m, ACT_TELEPORT_FADE_IN, 0)
        audioSample = audio_sample_load("PT Taunt Sound Effect.ogg");
        audio_sample_play(audioSample, gMarioStates[0].pos, 0.32)
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)
-------------------------------- end of crocket-------------------------------------------------------------------------


hook_chat_command("balling", "fr", function(msg)
    movesetTable[ACT_LONG_JUMP] = not movesetTable[ACT_LONG_JUMP]
    djui_chat_message_create(movesetactive and "oughmyfckingdick" or "vineboom.sfx")
    return true
end)

movesetTable = {

    [ACT_LONG_JUMP] = true,
}
function mario_update(m)
    if m.character.type ~= CT_LUIGI then return end
    if not movesetTable[ACT_LONG_JUMP] then return end
    local e = gStateExtras[m.playerIndex]
    e.scuttle = 0
    e.animFrame = 0
    local shouldScuttle = (m.action == ACT_LONG_JUMP)
    if shouldScuttle then
        if m.marioBodyState.wingFlutter == 1 then
            m.vel.y = m.vel.y + 1
        else
            set_mario_animation(m, MARIO_ANIM_FLUTTERKICK)
            set_anim_to_frame(m, e.animFrame)
            e.animFrame = e.animFrame + 6
            if e.animFrame >= m.marioObj.header.gfx.animInfo.curAnim.loopEnd then
                e.animFrame = e.animFrame - m.marioObj.header.gfx.animInfo.curAnim.loopEnd
            end
            if ((m.controller.buttonDown & A_BUTTON) ~= 0) then
                if m.vel.y < -5 then m.vel.y = m.vel.y + 4 end
                if m.vel.y > 5 then m.vel.y = m.vel.y + 0 end
                e.scuttle = 1
                m.forwardVel = m.forwardVel + 3.2
                m.faceAngle.y = m.intendedYaw
            end
        end
        if m.action == ACT_CROUCHING then
            e.crouchTimer = e.crouchTimer + 1
            if e.crouchTimer > 100 then
                e.jumpcharged = 1
            end
        elseif m.action ~= ACT_CROUCHING and m.action ~= ACT_IDLE and m.action ~= ACT_STOP_CROUCHING and m.action ~= ACT_START_CROUCHING and m.action ~= ACT_STOP_CRAWLING and m.action ~= ACT_START_CRAWLING and m.action ~= ACT_CRAWLING then
            e.crouchTimer = 0
            e.jumpcharged = 0
        end
    end
end

if gPlayerSyncTable[m.playerIndex].modelId ~= nil then
    obj_set_model_extended(m.marioObj, gPlayerSyncTable[m.playerIndex].modelId)
end

hook_event(HOOK_MARIO_UPDATE, mario_update)

ACT_MILNE_BOWSER_THROW = allocate_mario_action(ACT_GROUP_MOVING | ACT_FLAG_MOVING)
ACT_MILNE_BOWSER_THROW_AIR = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING)

function mario_update(m)
    if m.character.type ~= CT_LUIGI then return end
    if not movesetactive then return end
    if m.action == ACT_PICKING_UP_BOWSER then m.action = ACT_PICKING_UP end
end
hook_event(HOOK_MARIO_UPDATE, mario_update)



----------------------------------------------------------------------- M A R I O S T U F F --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------



ACT_SPIN_POUND_LAND = allocate_mario_action(ACT_GROUP_STATIONARY | ACT_FLAG_STATIONARY | ACT_FLAG_ATTACKING)
ACT_SPIN_POUND      = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_ATTACKING)

function act_spin_pound(m)
    if m.character.type ~= CT_MARIO then return end
    local e = gStateExtras[m.playerIndex]
    if m.actionTimer == 0 then
        m.actionState = m.actionArg
    end

    local spinDirFactor = 1 -- negative for clockwise, positive for counter-clockwise
    if m.actionState == 1 then spinDirFactor = -1 end

    set_mario_animation(m, MARIO_ANIM_TWIRL)

    m.particleFlags = m.particleFlags | PARTICLE_DUST

    if (m.controller.buttonDown & Z_TRIG) == 0 then
        set_mario_action(m, ACT_TWIRLING, 5)
    end

    local stepResult = perform_air_step(m, 0)
    if stepResult == AIR_STEP_LANDED then
        if should_get_stuck_in_ground(m) ~= 0 then
            queue_rumble_data_mario(m, 5, 80)
            play_character_sound(m, CHAR_SOUND_OOOF2)
            m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE
            set_mario_action(m, ACT_BUTT_STUCK_IN_GROUND, 0)
        else
            play_mario_heavy_landing_sound(m, SOUND_ACTION_TERRAIN_HEAVY_LANDING)
            if check_fall_damage(m, ACT_HARD_BACKWARD_GROUND_KB) == 0 then
                m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE | PARTICLE_HORIZONTAL_STAR
                set_mario_action(m, ACT_SPIN_POUND_LAND, 0)
            end
        end
        set_camera_shake_from_hit(SHAKE_GROUND_POUND)
    elseif stepResult == AIR_STEP_HIT_WALL then
        mario_set_forward_vel(m, -16.0)
        if m.vel.y > 0.0 then
            m.vel.y = 0.0
        end

        m.particleFlags = m.particleFlags | PARTICLE_VERTICAL_STAR
        set_mario_action(m, ACT_BACKWARD_AIR_KB, 0)
    end
end

function act_spin_pound_land(m)
    if m.character.type ~= CT_MARIO then return end
    m.actionState = 1

    if m.actionTimer <= 8 then
        if (m.input & INPUT_UNKNOWN_10) ~= 0 then
            return drop_and_set_mario_action(m, ACT_SHOCKWAVE_BOUNCE, 0)
        end

        if (m.input & INPUT_OFF_FLOOR) ~= 0 then
            return set_mario_action(m, ACT_FREEFALL, 0)
        end

        if (m.input & INPUT_ABOVE_SLIDE) ~= 0 then
            return set_mario_action(m, ACT_BUTT_SLIDE, 0)
        end

        stationary_ground_step(m)
        set_mario_animation(m, MARIO_ANIM_LAND_FROM_DOUBLE_JUMP)
    else
        if (m.input & INPUT_UNKNOWN_10) ~= 0 then
            return set_mario_action(m, ACT_SHOCKWAVE_BOUNCE, 0)
        end

        if (m.input & (INPUT_NONZERO_ANALOG | INPUT_A_PRESSED | INPUT_OFF_FLOOR | INPUT_ABOVE_SLIDE)) ~= 0 then
            return check_common_action_exits(m)
        end

        stopping_step(m, MARIO_ANIM_LAND_FROM_DOUBLE_JUMP, ACT_IDLE)
    end

    m.actionTimer = m.actionTimer + 1

    return 0
end

hook_mario_action(ACT_SPIN_POUND, { every_frame = act_spin_pound }, INT_GROUND_POUND_OR_TWIRL)
hook_mario_action(ACT_SPIN_POUND_LAND, { every_frame = act_spin_pound_land }, INT_GROUND_POUND_OR_TWIRL)


function mario_update(m)
    if m.character.type ~= CT_MARIO then return end
    local e = gStateExtras[m.playerIndex]


    -- twirl pound
    if m.action == ACT_TWIRLING and (m.controller.buttonDown & Z_TRIG) ~= 0 then
        set_mario_action(m, ACT_SPIN_POUND, 0)
    end

    -- backflip turns into twirl
    if m.action == ACT_BACKFLIP and m.marioObj.header.gfx.animInfo.animFrame > 18 then
        m.angleVel.y = 0x1800
        set_mario_action(m, ACT_TWIRLING, 1)
    end
end

hook_event(HOOK_MARIO_UPDATE, mario_update)

ACT_FUNNY_JUMP_CANCEL = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION |
ACT_FLAG_CONTROL_JUMP_HEIGHT)


function mario_on_set_action(m)
    if m.character.type ~= CT_MARIO then return end
    local e = gStateExtras[m.playerIndex]

   
    if m.action == ACT_FUNNY_JUMP_CANCEL then
        m.vel.y = 60
    end

    e.lastAction = action
end
hook_event(HOOK_ON_SET_MARIO_ACTION, mario_on_set_action)

function act_funny_jump_cancel(m)
    if m.character.type ~= CT_MARIO then return end
    local e = gStateExtras[m.playerIndex]
    if m.actionTimer == 0 then
        m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE
        e.animFrame = 68
        play_character_sound(m, CHAR_SOUND_HAHA)
        e.rotAngle = m.faceAngle.y
        e.animArg = math.floor(math.random(1, 2))
    end
    local stepResult = common_air_action_step(m, ACT_DOUBLE_JUMP_LAND,MARIO_ANIM_TWIRL ,
        AIR_STEP_CHECK_LEDGE_GRAB | AIR_STEP_CHECK_HANG)
        m.faceAngle.y = m.intendedYaw
    if (m.input & INPUT_Z_PRESSED) ~= 0 then
        return set_mario_action(m, ACT_GROUND_POUND, 0)
    end

    if (m.input & INPUT_NONZERO_ANALOG) ~= 0 then
        mario_set_forward_vel(m, math.abs(m.forwardVel))
    end

    if stepResult == AIR_STEP_LANDED then
        if should_get_stuck_in_ground(m) ~= 0 then
            queue_rumble_data_mario(m, 5, 80)
            play_sound(SOUND_MARIO_OOOF2, m.marioObj.header.gfx.cameraToObject)
            m.particleFlags = m.particleFlags | PARTICLE_MIST_CIRCLE
            set_mario_action(m, ACT_FEET_STUCK_IN_GROUND, 0)
        else
            play_sound(SOUND_ACTION_TERRAIN_LANDING, m.marioObj.header.gfx.cameraToObject)
            set_mario_action(m, ACT_DOUBLE_JUMP_LAND, 0)
        end
    end
    e.rotAngle = e.rotAngle + 0x2000
    m.marioObj.header.gfx.angle.y = e.rotAngle
    
    m.actionTimer = m.actionTimer + 1
    return 0
end

hook_mario_action(ACT_FUNNY_JUMP_CANCEL, { every_frame = act_funny_jump_cancel })


function mario_update(m)
 if m.character.type ~= CT_MARIO then return end
    local e = gStateExtras[m.playerIndex]
    if m.actionTimer == 0 then
        e.animFrame = 68
        e.rotAngle = m.faceAngle.y
        e.animArg = math.floor(math.random(1, 2))
    end
    e.rotAngle = e.rotAngle + 0x3000
    m.marioObj.header.gfx.angle.y = e.rotAngle
    -- double jump
    local shouldDoubleJump = (m.action == ACT_TRIPLE_JUMP or m.action == ACT_WALL_KICK or m.action == ACT_DOUBLE_JUMP or m.action == ACT_JUMP or m.action == ACT_SIDE_FLIP or m.action == ACT_BACKFLIP or m.action == ACT_FREEFALL or m.action == ACT_LONG_JUMP or m.action == ACT_SPIN_POUND or m.action == ACT_DIVE or m.action == ACT_TWIRLING )

    if shouldDoubleJump and m.actionTimer > 0 and (m.controller.buttonPressed & A_BUTTON) ~= 0 then
        return set_mario_action(m, ACT_FUNNY_JUMP_CANCEL, 0)
       
    end
    if shouldDoubleJump then
        m.actionTimer = m.actionTimer + 1
     
    end
end
hook_event(HOOK_MARIO_UPDATE, mario_update)

local can_press_x = 0

function x_pressed(m)
    if m.action == ACT_STAR_DANCE_EXIT or m.action == ACT_STAR_DANCE_NO_EXIT or m.action == ACT_STAR_DANCE_WATER or m.action == ACT_DEATH_EXIT  or m.action == ACT_DEATH_EXIT_LAND or m.action == ACT_DEATH_ON_BACK   or m.action ==   ACT_DEATH_ON_STOMACH or m.action == ACT_FALLING_DEATH_EXIT or m.action == ACT_QUICKSAND_DEATH  or m.action == ACT_SPECIAL_DEATH_EXIT then return end
    if m.health < 0x100 or m.hurtCounter ~= 0 then return end
    if (m.action & ACT_GROUP_MASK) == ACT_GROUP_SUBMERGED then return end
    if m.playerIndex ~= 0 then return end
    if m.character.type ~= CT_MARIO then return end
    if not movesetactive then return end
    if m.controller.buttonPressed & X_BUTTON ~= 0 then
        if x_press_counter > 0 then
            set_jumping_action(m, ACT_FUNNY_JUMP_CANCEL, 0)
            x_press_counter = x_press_counter - 1
        end
    end

    if (m.action & ACT_FLAG_AIR) == 0 then
        x_press_counter = 2
    end
end

hook_event(HOOK_MARIO_UPDATE, x_pressed)

function mario_before_phys_step(m)
    if m.character.type ~= CT_MARIO then return end
    if not movesetactive then return end 
    local e = gStateExtras[m.playerIndex]

    local hScale = 1.0
    local vScale = 1.0

    -- faster ground movement
    if (m.action & ACT_FLAG_MOVING) ~= 0 then
        hScale = hScale * 1.64
    end

  


    m.vel.x = m.vel.x * hScale
    m.vel.y = m.vel.y * vScale
    m.vel.z = m.vel.z * hScale
end
hook_event(HOOK_BEFORE_PHYS_STEP, mario_before_phys_step)